#include "stdafx.h"
#include "CListCtrlEx2.h"


BEGIN_MESSAGE_MAP(CListCtrlEx2, CListCtrl)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void CListCtrlEx2::OnPaint()
{
	if((GetStyle() & LVS_TYPEMASK)!=LVS_REPORT)
	{
		CListCtrl::OnPaint();
		return;
	}

	CPaintDC  dc(this);
	
	CHeaderCtrl* pHeader = GetHeaderCtrl();
	
	CRect header_rect;
	pHeader->GetClientRect(&header_rect);

	CFont Font2;
	{
		LOGFONT  mylf={0};
		{
			CFont* pFont = dc.GetCurrentFont();
			pFont->GetLogFont(&mylf);
		}
		
		mylf.lfHeight = 12;
		mylf.lfWidth = 6;
		mylf.lfWeight = FW_NORMAL;
		
		const int namesize=sizeof(mylf.lfFaceName);
		wchar_t name[namesize]=L"MS Sans Serif";
		memmove(mylf.lfFaceName,name,namesize);
		
		Font2.CreateFontIndirectW(&mylf);
	}

	CRect this_rect;
	GetClientRect(&this_rect);

	int y_max=0;

	//
	CFont* oldFint=dc.SelectObject(&Font2);
	for(int col=0; col<pHeader->GetItemCount(); col++)
	{
		const int topIndex = GetTopIndex();
		for (int item_inx=topIndex; item_inx<=GetCountPerPage();item_inx++)
		{
			CRect entire_item_rect;
			GetItemRect(item_inx,&entire_item_rect,LVIR_BOUNDS);
			y_max=max(y_max,entire_item_rect.bottom);
			
			CRect hdr_rect;
			pHeader->GetItemRect(col,&hdr_rect);

			CRect sub_item_rect=entire_item_rect;

			sub_item_rect.left =hdr_rect.left -GetScrollPos(SB_HORZ);
			sub_item_rect.right=hdr_rect.right-GetScrollPos(SB_HORZ);
			sub_item_rect.top++;
			sub_item_rect.bottom++;
			

			CString myText = GetItemText(item_inx,col);
#if 0
			dc.ExtTextOut(sub_item_rect.left, sub_item_rect.top, ETO_OPAQUE, &sub_item_rect, myText, NULL);
#else
			dc.DrawTextW(myText, &sub_item_rect, DT_CENTER|DT_VCENTER);
#endif

		}
	}
	dc.SelectObject(oldFint);

	// 
	{
		const int table_top=header_rect.bottom;
		int borderx = -GetScrollPos(SB_HORZ);
		for(int col=0; col<pHeader->GetItemCount(); col++)
		{
			CRect hdr_rect;
			pHeader->GetItemRect(col,&hdr_rect);

			borderx += GetColumnWidth(col);

			if(borderx>=this_rect.right)break;

			dc.MoveTo(hdr_rect.right-GetScrollPos(SB_HORZ),table_top);
			dc.LineTo(hdr_rect.right-GetScrollPos(SB_HORZ),y_max);
		}
	}

	// 
	const int table_width  = this_rect.right;
	for (int item_inx=0; item_inx<=GetCountPerPage();item_inx++)
	{
		CRect item_rect;
		GetItemRect(item_inx,&item_rect,LVIR_BOUNDS);

		dc.MoveTo(0          ,item_rect.bottom);
		dc.LineTo(table_width,item_rect.bottom);
	}
}
